%bcond_without	qt5
%bcond_without	qt6

Name:           libmygpo-qt
Version:        1.1.0
Release:        %mkrel 11
Summary:        Qt/C++ Library wrapping the gPodder.net Webservice
Group:          Graphical desktop/KDE
License:        GPLv3
URL:            https://github.com/gpodder/libmygpo-qt/
Source0:        http://stefan.derkits.at/files/libmygpo-qt/%{name}.%{version}.tar.gz
Patch1:         0001-Add-missing-Qt5Network-Qt5Test-make-BUILD_WITH_QT4-m.patch
Patch2:         0002-Fix-build-with-Qt-5.11_beta3-dropping-qt5_use_module.patch
Patch3:         0003-Move-MYGPO_BUILD_TESTS-option.patch
Patch4:         0004-Update-the-minimum-required-cmake-version-to-3.0.patch
Patch5:         0005-Fix-parsing-of-timestamp-for-EpisodeAction.patch
Patch6:         0006-Fix-timestamp-sent-to-gpodder.net-to-correspond-to-U.patch
Patch7:         0007-Fix-removeList-of-DeviceUpdates.patch
Patch8:         0008-Use-c-c-library-defined-ULLONG_MAX-instead-of-manual.patch
Patch9:         0009-Update-signals-and-slots-to-use-Q_SIGNALS-and-Q_SLOT.patch
Patch10:        0010-Bump-minimum-CMake-version-to-avoid-a-warning-during.patch
# https://github.com/gpodder/libmygpo-qt/pull/23
Patch20:        0001-Minimal-changes-to-make-Qt6-compilation-possible.patch
BuildRequires:  cmake
BuildRequires:  doxygen
# Qt5
%if %{with qt5}
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5Gui)
BuildRequires:  cmake(Qt5Network)
%endif
# Qt6
%if %{with qt6}
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Gui)
BuildRequires:  cmake(Qt6Network)
%endif

%description
libmygpo-qt is a Qt Library that wraps the gpodder.net Web API
(http://wiki.gpodder.org/wiki/Web_Services/API_2)

v1.0 wraps nearly every Request from the gpodder.net API except:
-) Simple API Calls Downloading subscription Lists & Uploading subscription
   Lists
-) Retrieving Subscription Changes (you should use "Retrieving Updates for a
   given Device" instead)

#-------------------------------------------------------------------------------
### Qt5 ###
%if %{with qt5}

%define mygpoqt5_major 1
%define libmygpo_qt5   %mklibname mygpo-qt5_ %{mygpoqt5_major}

%package -n %{libmygpo_qt5}
Summary:        Qt5/C++ Library wrapping the gPodder.net Webservice
Group:          Graphical desktop/KDE

Obsoletes:      %{_lib}mygpo-qt1 < 1.1.0-10

%description -n %{libmygpo_qt5}
Qt5/C++ Library wrapping the gPodder.net Webservice.

%files -n %{libmygpo_qt5}
%{_libdir}/libmygpo-qt5.so.%{mygpoqt5_major}{,.*}

#-------------------------------------------------------------------------------

%define mygpoqt5devel %mklibname mygpo-qt5 -d

%package -n %{mygpoqt5devel}
Summary:        Devel stuff for mygpo-qt5
Group:          Development/KDE and Qt
Requires:       %{libmygpo_qt5} = %{version}-%{release}
Provides:       mygpo-qt5-devel = %{version}-%{release}

Obsoletes:      %{_lib}mygpo-qt-devel < 1.1.0-10

%description -n %{mygpoqt5devel}
This package contains header files needed if you wish to build applications
based on mygpo-qt5.

%files -n %{mygpoqt5devel}
%{_qt5_includedir}/mygpo-qt/
%{_libdir}/pkgconfig/libmygpo-qt5.pc
%{_libdir}/libmygpo-qt5.so
%{_libdir}/cmake/mygpo-qt5/*.cmake
%dir %{_libdir}/cmake/mygpo-qt5
%endif

### End Qt5 ###

#-----------------------------------------------------------------------------

### Qt6 ###
%if %{with qt6}

%define mygpoqt6_major 1
%define libmygpo_qt6   %mklibname mygpo-qt6_ %{mygpoqt6_major}

%package -n %{libmygpo_qt6}
Summary:        Qt6/C++ Library wrapping the gPodder.net Webservice
Group:          Graphical desktop/KDE
Provides:       %{name} = %{version}-%{release}

%description -n %{libmygpo_qt6}
Qt6/C++ Library wrapping the gPodder.net Webservice.

%files -n %{libmygpo_qt6}
%{_libdir}/libmygpo-qt6.so.%{mygpoqt6_major}{,.*}

#-------------------------------------------------------------------------------

%define mygpoqt6devel %mklibname mygpo-qt6 -d

%package -n %{mygpoqt6devel}
Summary:        Devel stuff for %{name}
Group:          Development/KDE and Qt
Requires:       %{libmygpo_qt6} = %{version}-%{release}
Provides:       mygpo-qt6-devel = %{version}-%{release}

%description -n %{mygpoqt6devel}
This package contains header files needed if you wish to build applications
based on %{name}.

%files -n %{mygpoqt6devel}
%{_qt6_includedir}/mygpo-qt/
%{_libdir}/pkgconfig/libmygpo-qt6.pc
%{_libdir}/libmygpo-qt6.so
%{_libdir}/cmake/mygpo-qt6/*.cmake
%dir %{_libdir}/cmake/mygpo-qt6
%endif

### End Qt6 ###
#-----------------------------------------------------------------------------

%prep
%autosetup -p1 -n %{name}.%{version}

%build
%global _vpath_srcdir ..

%if %{with qt5}
### Qt5 build ###
mkdir -p qt5
pushd qt5
%cmake_qt5 \
        -DBUILD_WITH_QT6=OFF \
        -DMYGPO_BUILD_TESTS=OFF \
        -DINCLUDE_INSTALL_DIR=%{_qt5_includedir}/mygpo-qt
%cmake_build
popd
%endif

%if %{with qt6}
### Qt6 build ###
mkdir -p qt6
pushd qt6
%cmake_qt6 \
        -DBUILD_WITH_QT6=ON \
        -DMYGPO_BUILD_TESTS=OFF \
        -DINCLUDE_INSTALL_DIR=%{_qt6_includedir}/mygpo-qt
%cmake_build
popd
%endif

%install
%if %{with qt5}
### Qt5 install ###
pushd qt5
%cmake_install
popd
%endif

%if %{with qt6}
### Qt6 install ###
pushd qt6
%cmake_install
popd
%endif


%changelog
* Sun Dec 15 2024 daviddavid <daviddavid> 1.1.0-11.mga10
+ Revision: 2125339
- enable Qt6 support
- update Url to https://github.com/gpodder/libmygpo-qt/

* Thu Jul 25 2024 daviddavid <daviddavid> 1.1.0-10.mga10
+ Revision: 2082514
- drop old/unneeded Qt4 support
- prepare for feature Qt6 support

* Mon Apr 04 2022 umeabot <umeabot> 1.1.0-9.mga9
+ Revision: 1843284
- Mageia 9 Mass Rebuild

* Thu Dec 17 2020 umeabot <umeabot> 1.1.0-8.mga8
+ Revision: 1658872
- Rebuild for new Qt5

* Sat Feb 15 2020 umeabot <umeabot> 1.1.0-7.mga8
+ Revision: 1527902
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros
- build with new cmake macros

* Fri Jul 26 2019 daviddavid <daviddavid> 1.1.0-6.mga8
+ Revision: 1424446
- rebuild for new Qt5 headers path

* Sun Mar 31 2019 umeabot <umeabot> 1.1.0-5.mga7
+ Revision: 1383130
- Qt5 Rebuild

* Sun Jan 20 2019 daviddavid <daviddavid> 1.1.0-4.mga7
+ Revision: 1358311
- remove Qt4 '*.cmake' devel files in Qt5 devel sub-pkg

* Sun Sep 23 2018 umeabot <umeabot> 1.1.0-3.mga7
+ Revision: 1299024
- Mageia 7 Mass Rebuild

* Sun Jun 03 2018 daviddavid <daviddavid> 1.1.0-2.mga7
+ Revision: 1233795
- add upstream patch to fix build with new Qt5 >= 5.11.0

* Sun Apr 08 2018 kekepower <kekepower> 1.1.0-1.mga7
+ Revision: 1216234
- Update to version 1.1.0

* Fri Dec 30 2016 daviddavid <daviddavid> 1.0.9-3.mga6
+ Revision: 1078657
- add the support for Qt5 and make it the default in spec
- revert previous commit for lib pkg name

* Wed Dec 28 2016 daviddavid <daviddavid> 1.0.9-2.mga6
+ Revision: 1078557
- fix header location (should be in /usr/include/mygpo-qt/)
- fix lib pkg name

* Sat Dec 17 2016 luigiwalser <luigiwalser> 1.0.9-1.mga6
+ Revision: 1075810
- 1.0.9
- update URL

* Mon Feb 08 2016 umeabot <umeabot> 1.0.8-5.mga6
+ Revision: 948165
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.0.8-4.mga5
+ Revision: 742497
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.0.8-3.mga5
+ Revision: 726808
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.0.8-2.mga5
+ Revision: 681629
- Mageia 5 Mass Rebuild

* Sun Aug 17 2014 luigiwalser <luigiwalser> 1.0.8-1.mga5
+ Revision: 664509
- 1.0.8

* Sat Oct 19 2013 umeabot <umeabot> 1.0.7-2.mga4
+ Revision: 528569
- Mageia 4 Mass Rebuild

* Sun Jun 23 2013 luigiwalser <luigiwalser> 1.0.7-1.mga4
+ Revision: 445996
- 1.0.7
- remove upstreamed patch

* Sat Jan 12 2013 umeabot <umeabot> 1.0.6-2.mga3
+ Revision: 357816
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Dec 14 2012 fwang <fwang> 1.0.6-1.mga3
+ Revision: 330961
- do not build test
- drop merged patch
- new version 1.0.6

* Mon Dec 05 2011 dmorgan <dmorgan> 1.0.5-2.mga2
+ Revision: 176621
- Fix pkgconfig ( Version was missing)

* Sun Dec 04 2011 fwang <fwang> 1.0.5-1.mga2
+ Revision: 175983
- fix installation on 64 bit env
- update file list
- new version 1.0.5

* Thu Mar 24 2011 boklm <boklm> 1.0.0-2.mga1
+ Revision: 76179
- rebuild for bug #497

* Tue Mar 22 2011 mikala <mikala> 1.0.0-1.mga1
+ Revision: 75440
- imported package libmygpo-qt

